.nolist
#include "ion.inc"
#include "keyvals.inc"
.list
#ifdef TI83P
  .org    progstart-2
  .db     $BB,$6D
#else
  .org    progstart
#endif
  ret
  jr      nc,start
  .db     "Sprite Demonstration",0
				;SafeRam1 is a great place for variables, 768 bytes
xpos = SafeRam1			;X Position, 1 byte
ypos = SafeRam1+1		;Y Position, 1 byte
start:
	bcall(_clrlcdf)		;clear the whole screen
	bcall(_cleargbuf)	;clear the graph buffer
	ld a,43			;96/2 = middle of screen - 4 (half of width of sprite)
	ld (xpos),a
	ld a,28			;64/2 = middle of screen - 4 (half of height of sprite)
	ld (ypos),a
mainloop:
	call drawsprite		;draw the sprite to graph buffer
	call ionfastcopy	;copy the graph buffer to the screen
	call drawsprite		;erase the sprite from the graph buffer
	bcall(_getk)		;read keypresses
	cp gDown
	jp z,move.down
	cp gUp
	jp z,move.up
	cp gLeft
	jp z,move.left
	cp gRight
	jp z,move.right
	cp gClear
	jp z,return
	jp mainloop
move.down:
	ld a,(ypos)
	cp 56
	jp z,mainloop		;too far down already
	inc a
	ld (ypos),a
	jp mainloop
move.up:
	ld a,(ypos)
	cp 0			;too far up already
	jp z,mainloop
	dec a
	ld (ypos),a
	jp mainloop
move.left:
	ld a,(xpos)
	cp 0
	jp z,mainloop		;too far left
	dec a
	ld (xpos),a
	jp mainloop
move.right:
	ld a,(xpos)
	cp 88
	jp z,mainloop		;too far right
	inc a
	ld (xpos),a
	jp mainloop
drawsprite:
;////////////// SPECS FOR IONSPUTSPRITE:
;-----> Draw a sprite
; b=height of sprite
; l=y coord
; a=x coord
; ix holds pointer
;///////////////////////////////////////
	ld a,(ypos)
	ld l,a
	ld a,(xpos)
	ld b,8
	ld ix,ship
	call ionputsprite
	ret

return:
	ret

ship:	.db %00011000
	.db %00011000
	.db %00111100
	.db %10111101
	.db %10111101
	.db %11111111
	.db %11111111
	.db %00100100

.end
END